#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#define LINESIZE 80
#define ERR(x) fprintf(stderr, x)

typedef struct tabent{
	char c[LINESIZE];
	int p;
} tabent;

#include "kpa.h"

int tabsize[2];
#define STLPCE tabsize[1]
#define RIADKY tabsize[0]

char *stlpce,*riadky;
tabent *tab;
	
int main(int argc, char *argv[])
{
	FILE *fd;

	switch(argc) {
		case 3:
			fd=fopen(argv[1],"r");
			if(!fd) {
				ERR("Nemem otvori sbor s tabukou\n");
				exit(-1);
			}
			
			//dve cisla=stlpce*riadky
			gettabsize(fd);
			tab=malloc(RIADKY*STLPCE*sizeof(tabent));
			
			//hlavicka tabulky - terminaly a neterminaly
			stlpce=malloc(STLPCE*sizeof(char));
			riadky=malloc(RIADKY*sizeof(char));
			if(!(tab&&stlpce&&riadky)) {
				ERR("Nedostatok pamti.\n");
				exit(-1);
			}

			//zo suboru sa precita hlavicka a samotna tabulka
			readhead(fd,STLPCE,stlpce);
			readhead(fd,RIADKY,riadky);
			readtab(fd);
			
			//akceptovanie retazca
			accept_string(argv[2],"S");
			
			break;
		default:
			ERR("Pouitie: kpa <sbor s tabukou> <reazec>\n");
			exit(-1);
	}
			

	return(0);
}

void gettabsize(FILE *fd)
{
	char *line;
	
	line=getline(fd);
	if(!line) {
		ERR("V sbore nie je uveden vekos tabuky.\n");
		exit(1);
	}
	sscanf(line,"%d %d",&(RIADKY),&(STLPCE));
}

int readhead(FILE *fd, int s, char *where)
{
	char *line;
	int i;
	
	line=getline(fd);
	for(i=0;i<s;i++) {
		if(*line=='\0'||!line) {
			ERR("V sbore nie je sprvne uveden hlavika.\n");
			exit(1);
		}
		where[i]=*line;
		line=skipword(line);
	}
	return(0);
}

int readtab(FILE *fd)
{
	int i,j;
	char *l;
	
	for (i=0;i<RIADKY;i++) {
		l=getline(fd);
		if(!l) {
			ERR("V sbore s tabukou nie je dostaton poet riadkov.\n");
			exit(1);
		}
		for(j=0;j<STLPCE;j++) {
			if(!l) {
				fprintf(stderr,"V riadku tabuky %d nie je dostatony pocet poloiek\n",i);
				exit(1);
			}
			my_strcpy(tab[i*RIADKY+j].c,l);
			l=skipword(l);
			if(!l) {
				fprintf(stderr,"V riadku tabuky %d nie je dostatony poet poloiek\n",i);
				exit(1);
			}
			sscanf(l,"%d",&tab[i*RIADKY+j].p);
			l=skipword(l);
		}
	}
	return(0);
}

int accept_string(char *input, char *stack)
{
	char *newstack,*newinput;
	int i,j;
	
	if(!*stack) { //prazdny zasobnik
		if(!*input) { //ok
			return(0);
		}
		printf("Zsobnk sa vyprzdnil, na vstupe nieo je. To je zl.\n");
		exit(0);
	}
	if(!*input) { //prazdny vstup
		printf("Vstup sa vyerpal, no v zsobnku nieo zostalo.\n");
		return(0);
	}
	
	if(!isupper(*stack)) { //mame terminal na vrchu zasobnika...
		if(*input!=*stack) {
			printf("Na vrchu zsobnka je terminl, ktor sa nezhoduje s terminalom na vstupe.\n");
			exit(0);
		}
		newstack=stack+1;
		newinput=input+1;
#ifdef DEBUG
		printf("Vylil som terminl %c.\n",*stack);
#endif DEBUG
		return(accept_string(newinput,newstack));
	}

	//prehladame riadky tabulky a najdeme tam neterminal, ktory je na vrchu
	//zasobnika
	for(i=0;i<RIADKY;i++) {
		if(*stack==riadky[i]) {//nasli sme neterminal, hladame terminal
			for(j=0;j<STLPCE;j++) {
				if(*input==stlpce[j]) {//zhoduju sa terminaly
					if(*tab[i*RIADKY+j].c=='X') {
						printf("Chybov stav.\n");
						exit(0);
					}
					if(*tab[i*RIADKY+j].c=='e') {
						newstack=stack+1;
						newinput=input;
						printf("%d ",tab[i*RIADKY+j].p);
						return(accept_string(newinput,newstack));
					}
					newstack=malloc(strlen(stack)-1+strlen(tab[i*RIADKY+j].c));
					my_strcpy(newstack,tab[i*RIADKY+j].c);
					my_strcpy(newstack+strlen(newstack),stack+1);
					newinput=input;
					printf("%d ",tab[i*RIADKY+j].p);
					return(accept_string(newinput,newstack));
				}
			}
			printf("Njdeny neznmy terminl %c vo vstupnom reazci.\n",*input);
			exit(0);
		}
	}
	printf("Njden neznmy neterminl %c v zsobnku(o ma dos prekvapuje).", *stack);
	exit(1);
}
				
	

char *getline(FILE *fd)
{
	static char buff[LINESIZE];
	char *s;
	
	do {
		s=fgets(buff,LINESIZE,fd);
		if(!s) return(NULL);
		terminate(s);
		if(!s) continue;
		while(*s==' '||*s=='\t') s++;
		//printf("Riadok suboru:");puts(s);
		if(*s=='#') {*s='\0';continue;}
	} while(!strlen(s));
	return(s);
}

void terminate(char *c)
{
	register char *a;
        a=c;
	while(*a!='\n'&&*a!='\0'&&*a!='\r')a++;
        *a='\0';
}

char *skipword(char *p)
{
	char *n;
	n=p;
	
	while( ! (*n==' ' || *n=='\t' || *n==',' || *n=='\0') ) n++;
	if(!*n) return(NULL);
	while(*n==' ' || *n=='\t' || *n==',') n++;
	return(n);
}

int my_strcpy(register char *dest, register char *src)
{
	while(isalnum(*src)) {
		*dest=*src;
		src++;
		dest++;
	}
	*dest='\0';
	return(0);
}
